//
//  MapKitTutorialViewController.m
//  MapKitTutorial
//
//  Created by Sam  keene on 17/08/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "MapKitTutorialViewController.h"
#import <MapKit/MapKit.h>
#import "SydneyAnnotation.h"
#import "MapDetailView.h"

@implementation MapKitTutorialViewController
@synthesize mapView;

- (void)dealloc
{
    //dealloc
    [super dealloc];
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    self.mapView.mapType = MKMapTypeStandard;
    
    // set the map to show Sydney
    MKCoordinateRegion sydneyRegion;
    sydneyRegion.center.latitude = -33.870883;
    sydneyRegion.center.longitude = 151.2025;
    sydneyRegion.span.latitudeDelta = 0.05;
    sydneyRegion.span.longitudeDelta = 0.05;
    [self.mapView setRegion:sydneyRegion animated:YES];
    // annotation for Sydney
    SydneyAnnotation *sydneyAnnotation = [[SydneyAnnotation alloc] init];
    [self.mapView addAnnotation:sydneyAnnotation];
    [sydneyAnnotation release];
}

- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation
{
    
       static NSString* SydneyAnnotationIdentifier = @"SydneyAnnotationIdentifier";
   
        // if an existing pin view was not available, create one
        MKPinAnnotationView* pinView = [[[MKPinAnnotationView alloc]
                                               initWithAnnotation:annotation reuseIdentifier:SydneyAnnotationIdentifier] autorelease];
        pinView.pinColor = MKPinAnnotationColorPurple;
        pinView.canShowCallout = YES;
        
    UIButton* rightButton = [UIButton buttonWithType:UIButtonTypeDetailDisclosure];
    [rightButton addTarget:self
                    action:@selector(showDetails:)
          forControlEvents:UIControlEventTouchUpInside];
        pinView.rightCalloutAccessoryView = rightButton;
       return pinView;
     
}

- (void)showDetails:(id)sender
{
    MapDetailView *aMapDetailView = [[MapDetailView alloc] initWithNibName:@"MapDetailView" bundle:nil];
	[self.navigationController pushViewController:aMapDetailView animated:YES];
	[aMapDetailView release];
}

@end
